#!/bin/sh

make tga_applymap tga_plotmap foobar.map
errcode=$?
if [ $errcode != 0 ] ; then
	echo "Erreur sur le make:" $errcode
	exit 1
fi

export TGA_OUTILS_VERBOSE=yes

DD=Essais

if [ ! -d $DD ]
then
	mkdir $DD
fi

Image=Cisco.tga
Map=volcano.map
echo
./tga_applymap 1 $Image $Map $DD/applymap_Av_1.tga
./tga_applymap 2 $Image $Map $DD/applymap_Av_2.tga

Map=neon.map
echo
./tga_applymap 1 $Image $Map $DD/applymap_Bn_1.tga
./tga_applymap 2 $Image $Map $DD/applymap_Bn_2.tga

for f in Essais/apply*.tga
do
	bn=$(basename $f .tga).jpg
	cjpeg -quality 90 -progress -dct float $f > $bn
	display	$bn &
done

