#!/bin/sh

#

echo "------------------------------------------"
make -j tga_cadre tga_pattern tga_combine
errcode=$?
if [ $errcode != 0 ] ; then
	echo "Erreur sur le make:" $errcode
	exit 1
fi

export TGA_OUTILS_VERBOSE=yes

Image=C.tga
CJPEGOPT="-quality 92 -dct float -progressive "
DD=Essais
if [ ! -d $DD ]
then
	mkdir $DD
fi

sz=25

echo "------------------------------------------"
./tga_cadre filet	$Image $DD/cadre_filet.tga
./tga_cadre cracra	$Image $DD/cadre_cracra.tga $sz
cjpeg $CJPEGOPT $DD/cadre_cracra.tga > cadre-cracra.jpg &

./tga_cadre sweep	$Image $DD/cadre_sweep_1.tga 6 0 20 $sz
./tga_cadre sweep	$Image $DD/cadre_sweep_2.tga 200 200 200 $sz
./tga_combine $DD/cadre_sweep_1.tga $DD/cadre_sweep_2.tga diago		\
		$DD/cadre_sweep.tga 0 0 0
cjpeg $CJPEGOPT $DD/cadre_sweep.tga > cadre-sweep.jpg &

./tga_cadre bruit	$Image $DD/cadre_bruit.tga 66 133 200 $sz
cjpeg $CJPEGOPT $DD/cadre_bruit.tga > cadre-bruit.jpg &

./tga_cadre blablanux	$Image $DD/cadre_blablanux.tga 66 133 200 $sz
./tga_cadre filetg	$Image $DD/cadre_filetg.tga 100 200
./tga_pattern $DD/P.tga 48 48 reponse 200
./tga_cadre pattern	$Image $DD/pattern.tga $DD/P.tga $sz
./tga_cadre patt_degr	$Image $DD/patt_degr.tga $DD/P.tga $sz
./tga_cadre patt_rand	$Image $DD/patt_rand.tga $DD/P.tga $sz
rm $DD/P.tga

./tga_cadre burp0	$Image $DD/cadre_burp0.tga 12 142 33
cjpeg $CJPEGOPT $DD/cadre_burp0.tga > cadre-burp0.jpg &
./tga_cadre burp1	$Image $DD/cadre_burp1.tga 42 42
./tga_cadre burp2	$Image $DD/cadre_burp2.tga 22 42 0x75 0
cjpeg $CJPEGOPT $DD/cadre_burp2.tga > cadre-burp2.jpg &

./tga_cadre pixx	$Image $DD/cadre_pixx.tga  $sz 133
cjpeg $CJPEGOPT $DD/cadre_pixx.tga > cadre-pixx.jpg &

./tga_cadre wave0	$Image $DD/cadre_wave0.tga 10 10 50 100 150

./tga_cadre b84a	$Image $DD/cadre_b84a.tga 50 50 133
cjpeg $CJPEGOPT $DD/cadre_b84a.tga > cadre-b84a.jpg &
./tga_cadre b84b	$Image $DD/cadre_b84b.tga 50 50 133
cjpeg $CJPEGOPT $DD/cadre_b84b.tga > cadre-b84b.jpg &

./tga_cadre zsnd0	$Image $DD/cadre_zsnd0.tga 50 50 133
cjpeg $CJPEGOPT $DD/cadre_zsnd0.tga > cadre-zsnd0.jpg &

sleep 5 ; sync

