#!/bin/bash 

echo
echo "------------------------------------------"
export TGA_OUTILS_VERBOSE=yes

DD=Essais
if [ ! -d $DD ]
then
	mkdir $DD
fi

make tga_effects tga_cadre
errcode=$?
if [ $errcode != 0 ] ; then
	echo "Erreur sur le make:" $errcode
	exit 1
fi

echo "------------------------------------------"
SRC=laPoncha.tga
CJPEGOPT="-quality 90 -dct float -progressive "

./tga_effects $SRC x0		$DD/effect_x0.tga 100 100 100
./tga_effects $SRC x1		$DD/effect_x1.tga 
./tga_effects $SRC x2		$DD/effect_x2.tga 0 0 0
./tga_effects $SRC x3		$DD/effect_x3.tga 42 42 gb
./tga_effects $SRC x4		$DD/effect_x4.tga 42 
./tga_effects $SRC x5		$DD/effect_x5.tga 0 0 0
./tga_cadre filet $DD/effect_x5.tga /tmp/$$-a.tga
cjpeg $CJPEGOPT /tmp/$$-a.tga > eff-color-powers.jpg

./tga_effects $SRC 4bits	$DD/effect_4bits.tga 
./tga_effects $SRC class0	$DD/effect_class0.tga
./tga_effects $SRC decomp	$DD/effect_decomp.tga T
./tga_effects $SRC flatgray	$DD/effect_flatgray.tga 30
./tga_cadre filet $DD/effect_flatgray.tga /tmp/$$-b.tga
cjpeg $CJPEGOPT /tmp/$$-b.tga > eff-flatgray.jpg &

./tga_effects $SRC gray		$DD/effect_grayT.tga T
./tga_effects $SRC gray		$DD/effect_grayF.tga F
./tga_effects $SRC mirror	$DD/effect_mirror.tga
./tga_effects $SRC updown	$DD/effect_updown.tga
./tga_effects $SRC mosaic	$DD/effect_mosaic.tga
./tga_cadre filet $DD/effect_mosaic.tga /tmp/$$-c.tga
cjpeg $CJPEGOPT /tmp/$$-c.tga > eff-eq-mosaic.jpg &

./tga_effects $SRC photomaton	$DD/effect_photomaton.tga
./tga_effects $SRC negate	$DD/effect_negate.tga
./tga_cadre filet $DD/effect_negate.tga /tmp/$$-d.tga
cjpeg $CJPEGOPT /tmp/$$-d.tga > eff-negatif.jpg &

./tga_effects $SRC noise	$DD/effect_noise.tga 61
./tga_effects $SRC recurse	$DD/effect_recurse.tga 42
./tga_effects $SRC rgbmskh	$DD/effect_rgbmskh.tga 42
./tga_effects $SRC rgbmskv	$DD/effect_rgbmskv.tga 42

./tga_effects $SRC rot4pix	$DD/effect_rot4pix.tga 42
./tga_effects $SRC cont2x2	$DD/effect_cont2x2.tga 
./tga_effects $SRC cont2x2g	$DD/effect_cont2x2g.tga 

./tga_effects $SRC scratch	$DD/effect_scratch.tga 100
./tga_effects $SRC sinwave1	$DD/effect_sinwave1.tga 4.2 4.2 4.2 6.1 6.1 6.1
./tga_cadre filet $DD/effect_sinwave1.tga /tmp/$$-e.tga
cjpeg $CJPEGOPT /tmp/$$-e.tga > eff-sinwave.jpg &

./tga_effects $SRC water	$DD/effect_water_12.tga 12
./tga_cadre filet $DD/effect_water_12.tga /tmp/$$-f.tga
cjpeg $CJPEGOPT /tmp/$$-f.tga > eff-water-12.jpg &

./tga_effects $SRC water	$DD/effect_water_42.tga 42

./tga_effects $SRC swapcol	$DD/effect_swapcol_rg.tga rg
./tga_effects $SRC swapcol	$DD/effect_swapcol_gb.tga gb
./tga_effects $SRC swapcol	$DD/effect_swapcol_rb.tga rb
./tga_effects $SRC pixelX	$DD/effect_pixelX.tga 
./tga_effects $SRC pixelY	$DD/effect_pixelY.tga 


