#!/bin/bash 

echo "------------------------------------------"

DESTDIR=resz
if [ ! -d $DESTDIR ]
then
	echo making dir...
	mkdir $DESTDIR
fi

make tga_resize tga_showdiff
errcode=$?
if [ $errcode != 0 ] ; then
	echo "Erreur sur le make:" $errcode
	exit 1
fi

echo "------------------------------------------"

SRC=A.tga
export TGA_OUTILS_VERBOSE=yes

./tga_resize $SRC newsize $DESTDIR/size_512x256.tga 512 256 0
./tga_resize $SRC half $DESTDIR/size_half0.tga 0
./tga_resize $SRC half $DESTDIR/size_half1.tga 1
./tga_resize $SRC double $DESTDIR/size_double0.tga 0
./tga_resize $SRC double $DESTDIR/size_double1.tga 1
./tga_resize $SRC percent $DESTDIR/size_33percent.tga 33.33 0 0

echo "------------------------------------------"
