/*
		T G A _ O U T I L S
		-------------------

	fonctions communes  tous les outils - new 11 juin 2002

*/

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

/* non portable but useful function */
char *strdup(const char *s);

#define IN_FONCTION
#include  "tga_outils.h"

/*::------------------------------------------------------------------::*/
int
cherche_mot_clef(char *mot, mot_clef *liste, int *pmode, int *pnbarg)
{
int		idx = 0;

idx = 0;
while (liste[idx].nom != NULL)
	{
/* #if DEBUG_LEVEL
	fprintf(stderr, "check %12s  %8s\n",	liste[idx].nom,
						liste[idx].ptypes);
#endif */
	if ( ! strcmp(liste[idx].nom, mot) )
		{
		*pmode = liste[idx].code;
		*pnbarg = strlen(liste[idx].ptypes);	
#if DEBUG_LEVEL
		fprintf(stderr, "found! mode %d nbpar %d\n", *pmode, *pnbarg);
		sleep(1);
#endif
		return idx;
		}
	idx++;
	}

return -1;
}
/*::------------------------------------------------------------------::*/
int
liste_mots_clefs(mot_clef *liste, int flag)
{
mot_clef	*pmc;

if (42 != flag)
	{
	fprintf(stderr, "UH ?\n");
	}

pmc = liste;

printf("  commande  | type arg |  explication\n");
printf("------------+----------+----------------------\n");
while (pmc->nom != NULL)
	{
	if (pmc->aide != NULL)
		printf(" %-10s | %-8s |  %s\n",
			pmc->nom, pmc->ptypes, pmc->aide);
	pmc++;
	}
printf("------------+----------+----------------------\n");

return 0;
}
/*::------------------------------------------------------------------::*/
/*
 * INPUT	str	string to scan for an integer
 * 		pval	pointer to the retrun value
 * 		k	* not used *
 *
 * OUTPUT	1	successfuly make a conversion
 * 		0	strange error occured :(
 */

int	parse_int_param(char *str, int *pval, int k)
{
long	lfoo;
int	val;

val = (int)(lfoo = strtol(str, NULL, 0));

#if DEBUG_LEVEL
fprintf(stderr, "%s:%s: '%s'  ->  %ld  ->  %d\n",
		__FILE__, __func__, str, lfoo, val);
#endif

*pval = val;

return 1;
}

/*::------------------------------------------------------------------::*/

static Param		params[NB_PARAMS];

int 
parse_parametres(int argc, char *argv[], char *types, int prem)
{
int	foo, idxt;
int	entier;
double	flottant;
char	*cptr;

#if DEBUG_LEVEL
fprintf(stderr, "Parse params: types '%s' debut %d\n", types, prem);
#endif

/*
 *	init de la table des paramtres.
 */
for (foo=0; foo<NB_PARAMS; foo++)
	{
	params[foo].type = '?';
	}

for (foo=prem, idxt=0; foo<argc; foo++, idxt++)
	{
#if DEBUG_LEVEL
	fprintf(stderr, "\t%d/%d\t%c\t%s\n", foo, idxt, types[idxt], argv[foo]);
#endif
	switch (types[idxt])
	{
	case 'c':
		if (strlen(argv[foo])!=1)
			{
			fprintf(stderr, "bad length of char param\n");
			}
		else
			{
#if DEBUG_LEVEL
			fprintf(stderr, "char param = %d\n", *argv[foo]);
#endif
			params[idxt].type = 'c';
			params[idxt].p.i = *argv[foo];
			}
		break;
	case 'i':
		/*
 		 * En fait, ici, il serait bon de parser aussi les
 		 * parametres donnes en hexadecimal.
 		 */
		if (parse_int_param(argv[foo], &entier, 0)==1)
			{
			params[idxt].type = 'i';
			params[idxt].p.i = entier;
			}
		else
			{
			fprintf(stderr, "ERR parse int param %s\n", argv[foo]);
			exit(5);
			}
		break;

	case 's':
#if DEBUG_LEVEL
		fprintf(stderr, "%s: case s\n", __func__);
#endif
		if ((cptr=strdup(argv[foo]))!=NULL)	
			{
			params[idxt].type = 's';
			params[idxt].p.s = cptr;
			}
		else
			{
			fprintf(stderr, "ERR parse param %s\n", argv[foo]);
			exit(5);
			}
		break;

	case 'd':
		if (sscanf(argv[foo], "%lf", &flottant)==1)
			{
			params[idxt].type = 'd';
			params[idxt].p.d = flottant;
			}
		else
			{
			fprintf(stderr,"ERR parse float param %s\n",argv[foo]);
			exit(5);
			}
		break;

	case 'f':
		switch(argv[foo][0])
			{
			case '0': case 'f': case 'F': case 'n': case 'N':
				params[idxt].type = 'f';
				params[idxt].p.i = 0;
				break;
			case '1': case 't': case 'T': case 'y': case 'Y':
				params[idxt].type = 'f';
				params[idxt].p.i = 1;
				break;
			default:
				fprintf(stderr, "bad flag %s\n", argv[foo]);
				exit(5);
			}
		break;

	default:
		fprintf(stderr, "partype #%d '%c' invalid\n",
					idxt, types[idxt]);
		exit(5);
		}
	}

return 0;
}
/*::------------------------------------------------------------------::*/
/*	affichage de la liste des parametres trouves			*/

void print_parametres(void)
{
int	foo;
printf("   +------+-----+\n");
printf("   | parameters |\n");
printf("   +------+-----+\n");
for (foo=0; foo<NB_PARAMS; foo++)
	{
	printf("   |   %d  |  %c  |\n", foo, params[foo].type);
	}
printf("   +------+-----+\n");
fflush(stdout);
}

/*::------------------------------------------------------------------::*/
/*
 *	fonctions de rcuperation d'un paramtre.
 */

int	GIP(int rang)
{
if (rang<0 || params[rang].type!='i')
	{
	fprintf(stderr, "erreur GIP %d\n", rang);
	exit(5);
	}
return params[rang].p.i;
}

int	GCP(int rang)
{
if (rang<0 || params[rang].type!='c')
	{
	fprintf(stderr, "erreur GCP %d\n", rang);
	exit(5);
	}
return params[rang].p.i;
}

/* get an 'int' parameter with a default value */
int	GIPdef(int rang, int def)
{
if (rang<0 || params[rang].type!='i')
	{
	return def;
	}
return params[rang].p.i;
}

char *	GSP(int rang)
{
#if DEBUG_LEVEL
fprintf(stderr, "GetStringParameter(%d)\n", rang);
#endif
if (rang<0 || params[rang].type!='s')
	{
	fprintf(stderr, "erreur GSP %d\n", rang);
	exit(5);
	}
return params[rang].p.s;
}

double	GDP(int rang)
{
if (rang<0 || params[rang].type!='d')
	{
	fprintf(stderr, "erreur GDP %d\n", rang);
	exit(5);
	}
return params[rang].p.d;
}

int	GFP(int rang)
{
if (rang<0 || params[rang].type!='f')
	{
	fprintf(stderr, "erreur GFP %d\n", rang);
	exit(5);
	}
return params[rang].p.i;
}

/*::------------------------------------------------------------------::*/
int
must_be_verbose(void)
{
char	*envvar;

envvar = getenv(NOM_VAR_ENV_VERBOSE);
if ((envvar!=NULL) && !strcmp(envvar, "yes"))	return 1;
return 0;
}
/*::------------------------------------------------------------------::*/
int
dump_command_line(int argc, char *argv[], int force)
{
char	*envvar;
int	flag=0, foo;

envvar = getenv(NOM_VAR_ENV_VERBOSE);
if ( (envvar!=NULL) && !strcmp(envvar, "yes") )		flag = 1;

if (flag || force)
	{
	fprintf(stderr, "TGA(%d)", getpid());
	for (foo=0; foo<argc; foo++)
		fprintf(stderr, " %s", argv[foo]);
	fprintf(stderr, "\n");
	}
return flag;
}
/*::------------------------------------------------------------------::*/
