/*
		tga_outils.h
		------------
*/

#include  <unistd.h>
#include  <image.h>

#define  TGA_OUTILS_VERSION   "0.32"
/*
 *	13 Dc 2001: v0.11  cause du 'mustopen' pour les palettes.
 *	11 Fv 2002: v0.12  cause du '-ansi' (hein Kerdeuzz, on y vient)
 *	21 Nov 2002: v0.13  cause du parser de paramtres.
 *	14 Jan 2006: v0.14 parce que je remet le truc dans le net.
 *	05 Jan 2007: v0.15 pour tre synchrone avec la doc.
 *	11 Dec 2007: v0.22 pour le parser de parametres (hexadecimal)
 */

#define TGA_OUTILS_COPYLEFT "(g) TontonTh 2008"
#define TGA_WWW_SITE "http://la.buvette.org/devel/libimage/"

#define PERR(txt) fprintf(stderr, "\t| %s\n", (txt))
#define PERL fprintf(stderr, "\t+-----------------------------------------\n")

#define NOM_VAR_ENV_VERBOSE "TGA_OUTILS_VERBOSE"      /* flag ON = "yes" */

int	must_be_verbose(void);

/*::------------------------------------------------------------------::*/
/*
 *	structure de description d'un mot-clef
 *	--------------------------------------
 *
 *	types des paramtres (chaine pointe par ptype)
 *
 *		i	entier 32 bits / char parameter
 *		s	chaine de caractres
 *		d	double flottant
 */
typedef struct 
	{
	char	*nom;
	int	code;
	char   *ptypes;		/* type des paramtres */
	char   *aide;
	char	*longhelp;
	} mot_clef;

#define NB_PARAMS 10		/* max number of allowed parameters */

/*
 *	structure contenant un paramtre.
 */
typedef struct
	{
	char	type;
	union
		{
		int	i;
		char	*s;
		double	d;
		} p;
	} Param;

int cherche_mot_clef(char *mot, mot_clef *liste, int *pmode, int *pnbarg);

/* le flag ne sert a rien, mais il faur le mettre a 42 */
int liste_mots_clefs(mot_clef *liste, int flag);

int	parse_int_param(char *str, int *pval, int k);

int	parse_parametres(int ac, char *av[], char *types, int prem);
void	print_parametres(void);

int	GIP(int rang);
int	GCP(int rang);
int	GIPdef(int rang, int def);
char *	GSP(int rang);
double	GDP(int rang);
int	GFP(int rang);			/* get flag */

/*::------------------------------------------------------------------::*/
/*
 *	fonctions de bavardage
 */
int dump_command_line(int argc, char *argv[], int force);

/*::------------------------------------------------------------------::*/
/*
 *	pour plus de details, for more informations
 *	http://la.buvette.org/devel/libimage/img-outils.html
 *	----------------------------------------------------
 */

