/*

	Diffrences entre deux images de mme taille.
	_____________________________________________

*/

#include  <stdio.h>
#include  <stdlib.h>

#include  <image.h>
#include  "tga_outils.h"

/*::------------------------------------------------------------------::*/

#define SHD_0		0
#define SHD_1		1
#define SHD_2		2
#define SHD_3		3
#define SHD_4		4
#define SHD_S0		5

mot_clef mots_clefs[] =
	{
	{ "0",  SHD_0,   "",		"no param" },
	{ "1",  SHD_1,   "i",		"euh..." },
	{ "2",  SHD_2,   "",		"euh..." },
	{ "3",  SHD_3,   "iii",		"r, g & b in [1..254]" },
	{ "4",  SHD_4,   "",		"euh..."			},
	{ "s0", SHD_S0,	 "",		"stro picture"		}
	};

/*::------------------------------------------------------------------::*/
void usage(int flag)
{
fprintf(stderr, "* tga_showdiff v 0.0.19 [%s] %s\n",
				TGA_OUTILS_VERSION, TGA_OUTILS_COPYLEFT);
fprintf(stderr, "usage:\n\ttga_showdiff iA.tga iB.tga mode dst.tga [pars]\n\n");

Image_print_version(0);
liste_mots_clefs(mots_clefs, 0); 
exit(5);
}
/*::------------------------------------------------------------------::*/
int main (int argc, char *argv[])
{
Image_Desc	*im1, *im2, *dest;
int		foo, idx, mode, nbarg;

dump_command_line(argc, argv, 0);

/*
 *	dcodage de la ligne de commande
 */
if (argc < 5)		usage(0);

idx = cherche_mot_clef(argv[3], mots_clefs, &mode, &nbarg);
if (mode < 0)
	{
	fprintf(stderr, "mot-clef %s inconnu\n", argv[3]);
	exit(5);
	}
#if DEBUG_LEVEL
else
	fprintf(stderr, "mot-clef: idx %d, mode %d, nbarg %d\n", 
					idx, mode, nbarg); 
#endif

/*
 *	ensuite, dcodage des paramtres... (bug in progress)
 */
	
/*
 *	lecture des images sources
 */
if ((im1 = Image_TGA_alloc_load(argv[1]))==NULL)
	{
	fprintf(stderr, "can't load image #1 %s\n", argv[1]);
	exit(5);
	}
if ((im2 = Image_TGA_alloc_load(argv[2]))==NULL)
	{
	fprintf(stderr, "can't load image #2 %s\n", argv[2]);
	exit(5);
	}
if ( (foo=Image_compare_desc(im1, im2)) )
	{
	fprintf(stderr, " im1 != im2: %d - %s\n", foo, Image_err2str(foo));
	exit(5);
	}
/*
 *	cration image destination 
 */
if ((dest = Image_clone(im2, 0))==NULL)
	{
	fprintf(stderr, "can't clone destination image...\n");
	exit(5);
	}


switch (mode)
	{
	case SHD_0:
		foo = Image_showdiff_0(im1, im2, dest);
		break;
	case SHD_1:
		foo = Image_showdiff_1(im1, im2, dest, 0);
		break;
	case SHD_2:
		/* parameter 42 is wrong. fix it. utsl */
		foo = Image_showdiff_2(im1, im2, dest, 42);
		break;
	case SHD_3:
		foo = Image_showdiff_3(im1, im2, dest, 20, 20, 20);
		break;
	case SHD_4:
		foo = 406;
		break;
	case SHD_S0:
		foo = Image_combine_stereo_0(im1, im2, dest);
		break;
	}

if (foo)
	{
	fprintf(stderr, "showdiff mode %s (%d): %d -> %s\n",
				argv[3], mode, foo, Image_err2str(foo));
	}

foo = Image_TGA_save(argv[4], dest, 0);

return 0;
}
/*::------------------------------------------------------------------::*/
