/*
       _____    _    __     ___     _             
      |_   _|__| | __\ \   / (_)___(_) ___  _ __  
        | |/ _ \ |/ _ \ \ / /| / __| |/ _ \| '_ \ 
        | |  __/ |  __/\ V / | \__ \ | (_) | | | |
        |_|\___|_|\___| \_/  |_|___/_|\___/|_| |_|
                                            
*/

#include  <stdio.h>
#include  <stdlib.h>
#include  <image.h>
#include  "tga_outils.h"

/*::------------------------------------------------------------------::*/
void usage(int flag)
{
fprintf(stderr, "* tga_television v 0.0.7 [%s] %s\n",
				TGA_OUTILS_VERSION, TGA_OUTILS_COPYLEFT);
fprintf(stderr, "Usage:tga_television M <src.tga> <dst.tga> <yo>\n");
Image_print_version(0);
exit(5);
}
/*::------------------------------------------------------------------::*/
#define TV_GRINK	2
#define TV_GROK		4
#define TV_GRUUD	6
#define TV_GRIIIZ	8
#define TV_OLD		20
mot_clef mots_clef[] =
{
{ "grink",	TV_GRINK,	"i",	"..."				},
{ "grok",	TV_GROK,	"i",	"..."				},
{ "gruud",	TV_GRUUD,	"i",	"..."				},
{ "griiiz",	TV_GRIIIZ,	"i",	"parameter must be 0"		},
{ "oldstyle",	TV_OLD,		"iii",  "..."				}
};
/*::------------------------------------------------------------------::*/
int main(int argc, char *argv[])
{
Image_Desc	*src, *dst;
int		foo, mode;
int		par[NB_PARAMS], nb_int_par, value;
int		commande, nbargs;

dump_command_line(argc, argv, 0);

if (argc < 4) usage(1);

srand(getpid());

if ( (src=Image_TGA_alloc_load(argv[2])) == NULL )
	{
	fprintf(stderr, "can't load '%s'\n", argv[2]);
	exit(1);
	}

if ( (dst=Image_clone(src, 0))==NULL )
	{
	fprintf(stderr, "can't clone %p, exiting...\n", src);
	exit(2);
	}

/*
 *	rechercher le mot clef dans la table
 */
mode = cherche_mot_clef(argv[1], mots_clef, &commande, &nbargs);
if (mode < 0)
	{
	fprintf(stderr, "mot-clef %s inconnu\n", argv[1]);
	exit(5);
	}

/*
 *	decoder les arguments
 */
for (foo=0; foo<NB_PARAMS; foo++)	par[foo]=0;
nb_int_par = 0;
for (foo=4; foo<argc; foo++)
	{
	if ( sscanf(argv[foo], "%d", &value)==1 )
		{
		par[foo-4] = value;
		nb_int_par++;
		}
	}

switch (commande)
	{
	case TV_GRINK:
		foo = Image_TV_grink(src, dst, par[0]);
		break;

	case TV_GROK:
		foo = Image_TV_grok(src, dst, par[0]);
		break;

	case TV_GRUUD:
		foo = Image_TV_gruud(src, dst, par[0]);
		break;

	case TV_GRIIIZ:
		foo = Image_TV_griiiz(src, dst, par[0]);
		break;

	case TV_OLD:
		foo = Image_TV_old(src, dst, par[0], par[1], par[2]);
		break;

	default: 
		fprintf(stderr, "commande %d inconnue\n", commande);
		break;
	}

foo = Image_TGA_save(argv[3], dst, 0);
if (foo)
	{
	fprintf(stderr, "%s: TGA_save: err %d %s\n",
			argv[0], foo, Image_err2str(foo));
	exit(1);
	}

exit (0);
}
/*::------------------------------------------------------------------::*/
