#include  <stdio.h>
#include  <stdlib.h>
#include  <image.h>

#include  "tga_outils.h"

/*::------------------------------------------------------------------::*/
#define		VERSION		1
#define		PLOP		2
#define		GETDIMS		4
#define		GETDIMX		5
#define		GETDIMPOV	6
#define		GRMINMAX	17	/* min & max in gray level */
#define		HEADER		33
#define		TIMESTAMP	34
#define		PRHISTO		35
#define		ENVIRON		50
/*::------------------------------------------------------------------::*/
mot_clef commandes[] = 
{
{ "version",	VERSION,	"",	"version de la libimage"	},
{ "plop",	PLOP,		"", 	"marre des plopeuses"		},
{ "getdims",	GETDIMS,	"s",	"dimensions d'une targa"	},
{ "getdimx",	GETDIMX,	"s",	"dimensions d'une targa"	},
{ "getdimpov",	GETDIMPOV,	"s",	"dimensions d'une targa"	},
{ "grminmax",	GRMINMAX,	"si",	"image.tga K"			},
{ "header",	HEADER,		"s",	"filename of image"		},
{ "timestamp",	TIMESTAMP,	"ss",	"filename message"		},
{ "prhisto",	PRHISTO,	"s",	"filename.tga"			},
{ "environ",	ENVIRON,	"",	""				},
{ "foooo",	9999,		"",	"Pffeeeuuuu"			}
};

/*::------------------------------------------------------------------::*/
int
print_tga_dims(char *filename, int flags)
{
int	foo, width, height;

#if DEBUG_LEVEL
fprintf(stderr, "%s:%d %s ( %s, %d )\n", __FILE__, __LINE__,
			__func__, filename, flags);
#endif
foo = Image_TGA_get_dims(filename, &width, &height);
if (foo)
	{
	fprintf(stderr, "something is bad with %s : %d\n", filename, foo);

	}

switch(flags)
	{
	case 0:
		printf("%8d %8d", width, height);
		break;
	case 1:
		printf("%dx%d", width, height);
		break;
	case 2:
		printf(" -w%d -h%d ", width, height);
		break;
	default:
		fprintf(stderr, "bad flag %d in %s\n", flags, __func__);
		abort();
		break;			/* unreached ? */
	}
return foo;
}
/*::------------------------------------------------------------------::*/
int showheader(char *filename, int flag)
{
int		foo;

fprintf(stderr, "Show Header '%s' %d\n", filename, flag);

foo = Image_TGA_show_header(filename, 0);

return foo;
}
/*::------------------------------------------------------------------::*/
int timestamp(char *fnin, char *fnout, char *txt, int flag)
{
int		foo;
/*
 * figurez vous, chers amis lecteurs de goret-code, que je n'ai plus
 * la moindre idee de ce que je voulais mettre ici :)
 */
foo = 51;
return foo;
}
/*::------------------------------------------------------------------::*/
int print_histogramme(char *filename, int flags)
{
Image_Desc	*src;
long		hr[256], hg[256], hb[256];
int		foo;

if ( (src=Image_TGA_alloc_load(filename)) == NULL )
	{
	fprintf(stderr, "tga_tools, chargement '%s' failed\n", filename);
	exit(5);
	}
foo = Image_histo_RGB(src, hr, hb, hg);
if (foo)
	{
	fprintf(stderr, "tga_tools, calcul histogramme: %d  %s\n",
						foo, Image_err2str(foo));
	exit(5);
	}

for (foo=0; foo<256; foo++)
	{
	printf("%3d   %8ld   %8ld   %8ld\n", foo, hr[foo], hg[foo], hb[foo]);
	}

return 0;
}
/*::------------------------------------------------------------------::*/
/* new 27 mars 2008 - avenue St Exupery */
int print_environ(void)
{
int	foo;
char	*ptr;
char	*noms[] = 
	{
	"FOOBAR", NOM_VAR_ENV_VERBOSE, "LIBIMAGE_PATH"
	};

for (foo=0; foo<(sizeof(noms)/sizeof(char *)); foo++)
	{
	ptr = getenv(noms[foo]);
	printf("%5d  %-25s  %s\n", foo, noms[foo], ptr);
	}

return FUNC_NOT_FINISH;
}
/*::------------------------------------------------------------------::*/
int main (int argc, char *argv[])
{
int		foo;
int		idx, mode, nbarg;
char		* cptr;

dump_command_line(argc, argv, 0);

if (1 == argc)
	{
	liste_mots_clefs(commandes, 42);
	exit(0);
	}

if (-1 == (idx=cherche_mot_clef(argv[1], commandes, &mode, &nbarg)) )
	{
	fprintf(stderr, "action '%s' inconnue.\n", argv[1]);
	exit(1);
	}
#if DEBUG_LEVEL
fprintf(stderr, "%s commande: idx=%d mode=%d nbarg=%d\n",
			argv[0], idx, mode, nbarg);
#endif

#define FIRST_PARAM	2
foo = parse_parametres(argc, argv, commandes[idx].ptypes, FIRST_PARAM);

switch(mode)
	{
	case VERSION:
		Image_print_version(1);
		printf("Version des outils: %s  ", TGA_OUTILS_VERSION);
		printf("-  %s,  %s\n", __DATE__, __TIME__);
		break;
	case PLOP:
		printf("Marre des plopeuses et des plopeurs :)\n");
		break;
	case GETDIMS:
		cptr = GSP(0);
#if DEBUG_LEVEL
		fprintf(stderr, "GETDIMS %s\n", cptr);
#endif
		foo = print_tga_dims(cptr, 0);
		break;
	case GETDIMX:
		cptr = GSP(0);
		foo = print_tga_dims(cptr, 1);
		break;
	case GETDIMPOV:
		cptr = GSP(0);
		foo = print_tga_dims(cptr, 2);
		break;
	case HEADER:
		foo = showheader(GSP(0), 0);
		break;
	case PRHISTO:
		foo = print_histogramme(GSP(0), 0);
		break;
	case ENVIRON:
		foo = print_environ();
		break;
	default:
		fprintf(stderr, "Hu ho %d ?\n", mode);
		break;
	}
return 0;
}
/*::------------------------------------------------------------------::*/
